-- First time messing with the sign... Here goes nothin'.
addHook("MobjThinker", function(mo)
    if not mo.valid or not mo.target or not mo.target.player or mo.spawnedClone then return end
    local player = mo.target.player
    
    if (mo.state == S_SIGNPLAYER) and (mo.Clone != nil) then
        -- Main character
        local ov = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
        ov.target = mo.tracer
        ov.state = S_PLAY_SIGN
        
        ov.skin = mo.Clone
        ov.color = player.skincolor
        ov.colorized = true
        
        -- Icons of everyone used
        if #mo.usedClone - 1 == 1 then
            for i, n in pairs(mo.usedClone) do
                if n == mo.Clone then continue end
                local h = P_SpawnMobj(mo.x,mo.y,mo.z + P_MobjFlip(mo)*96*mo.scale + max(-P_MobjFlip(mo)*16*mo.scale, 0), MT_CFHEAD)
                h.scale = mo.scale
                h.eflags = mo.eflags
                h.skin = n
                h.color = player.skincolor
            end
        elseif #mo.usedClone > 1 then
            local inc = FixedAngle(360*FRACUNIT/(#mo.usedClone-1))
            local g = 1
            for _, n in pairs(mo.usedClone) do
                if n == mo.Clone then continue end
                local a = (inc/2) + mo.angle + g*inc
                local h = P_SpawnMobj(mo.x+32*cos(a),mo.y+32*sin(a),mo.z + P_MobjFlip(mo)*96*mo.scale + max(-P_MobjFlip(mo)*16*mo.scale, 0), MT_CFHEAD)
                h.scale = mo.scale
                h.eflags = mo.eflags
                h.skin = n
                h.color = player.skincolor
                g = $+1
            end
        end
        
        -- go away!!!!!!!!
        mo.spawnedClone = true
    
    elseif (mo.state == S_SIGNSPIN1) and (player.skin == #skins["clonefighter"]) and not mo.Clone then
        mo.Clone = player.mo.skin
        mo.usedClone = player.CF.signUsed
    end
end, MT_SIGN)